/*!	@file
	@brief Ruby}N

	@author Sakura-Editor collaborators
	@date 2013.12.16
*/
/*
	Copyright (C) 2013, Sakura-Editor collaborators

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose, 
	including commercial applications, and to alter it and redistribute it 
	freely, subject to the following restrictions:

		1. The origin of this software must not be misrepresented;
		   you must not claim that you wrote the original software.
		   If you use this software in a product, an acknowledgment
		   in the product documentation would be appreciated but is
		   not required.

		2. Altered source versions must be plainly marked as such, 
		   and must not be misrepresented as being the original software.

		3. This notice may not be removed or altered from any source
		   distribution.
*/

#include "StdAfx.h"
#include <string.h>
#include "CRubyMacroMgr.h"
#include "mem/CMemory.h"
#include "CMacroFactory.h"
#include "io/CTextStream.h"

///////////////////////////////////////////////////////////////////////////////
CRuby CRubyMacroMgr::m_cRuby;

///////////////////////////////////////////////////////////////////////////////
CRubyMacroMgr::CRubyMacroMgr()
{
}

///////////////////////////////////////////////////////////////////////////////
CRubyMacroMgr::~CRubyMacroMgr()
{
}

///////////////////////////////////////////////////////////////////////////////
/** Ruby}Ns
	@param[in/out]	pcEditView	r[
	@param[in]		flags		tO
*/
bool CRubyMacroMgr::ExecKeyMacro(CEditView* pcEditView, int flags) const
{
	//UTF-8Ȃ?
	std::string code = to_achar(m_cBuffer.GetStringPtr());
	return m_cRuby.Execute(code.c_str(), pcEditView, flags);
}

///////////////////////////////////////////////////////////////////////////////
/*! t@C}Nǂݍ
	@param[in]	hInstance	CX^X
	@param[in]	lpszPath	t@CpX
*/
BOOL CRubyMacroMgr::LoadKeyMacro(HINSTANCE hInstance, const TCHAR* lpszPath)
{
	BOOL bResult = FALSE;
	m_nReady = false;
	CTextInputStream in(lpszPath);
	if(in){
		CNativeW cmemLineCode;
		while(in){
			std::wstring strLine = in.ReadLineW();
			strLine += L"\n";
			cmemLineCode.AppendString(strLine.c_str());
		}
		in.Close();
		m_cBuffer.SetNativeData(cmemLineCode);
		m_nReady = true;
		bResult = TRUE;
	}
	return bResult;
}

///////////////////////////////////////////////////////////////////////////////
/*! 񂩂}Nǂݍ
	@param[in]	hInstance	CX^X
	@param[in]	lpszCode	R[h
*/
BOOL CRubyMacroMgr::LoadKeyMacroStr(HINSTANCE hInstance, const TCHAR* lpszCode)
{
	m_cBuffer.SetNativeData(to_wchar(lpszCode));
	m_nReady = true;
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
/*!	̃XNvg̊gqȂIuWFNg𐶐
	@param[in]	ext	gq
*/
CMacroManagerBase* CRubyMacroMgr::Creator(const TCHAR* ext)
{
	if(_tcscmp(ext, _T("mrb")) == 0){
		return new CRubyMacroMgr;
	}
	return NULL;
}

///////////////////////////////////////////////////////////////////////////////
/*!	CRubyMacroManagero^
*/
void CRubyMacroMgr::declare(void)
{
	if(m_cRuby.InitDll() == DLL_SUCCESS){
		CMacroFactory::getInstance()->RegisterCreator(Creator);
	}
}
